// 001 u_udf_globals
// 01 apr 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_udf_globals;
  interface
    uses Windows, SysUtils;

    function f_build_pchar(p_source_pchar, p_destination_pchar: PChar; p_length: DWORD): PChar;

  implementation

    function malloc(Size: Integer): Pointer; cdecl; external 'msvcrt.dll' ;

    function f_build_pchar(p_source_pchar, p_destination_pchar: PChar; p_length: DWORD): PChar;
      begin
        result:= p_destination_pchar;

        if (result= nil)
          then
            begin
              if (p_length= 0)
                then p_length:= StrLen(p_source_pchar)+ 1;
              result:= malloc(p_length);
            end;

        if (p_source_pchar<> result)
          then
            begin
              if (p_source_pchar= nil) or (p_length= 1)
                then result[0]:= #0
                else Move(p_source_pchar^, result^, p_length);
            end;
      end; // f_build_pchar

    end.
